unit HTMLCommon;

interface

uses Classes;

type
  // t@C^Cv
  TFileType = record
    PaternName: String;
    Patern: String;
  end;

  // AhD
  TUndoType = (unNone, unInsert, unDelete);
  TUndo = record
    UndoType: TUndoType;
    UndoStartPoint: Integer;
    UndoEndPoint: Integer;
    MotoStr: String;
    HendoStr: String;
  end;
  TUndoList = Array of TUndo;

const
  html_config = 'HTMLEditor.conf';
  html_preset = 'HTMLEditor.pre';
  html_list = 'HTMLEditor.lst';

  TypeCnt = 3;

  SHIFT_JIS = 932; // VtgJIS
  UTF_16 = 1200; // UTF-16
  UTF_32 = 12000; // UTF-32
  UTF_7 = 65000; // UTF-7
  UTF_8 = 65001; // UTF-8
  EUC_JP = 20932; // EUC

  UndoMax_Default = 1000;

  Default_Width = 960;
  Default_Height = 750;
  Default_Left = 120;
  Default_Top = 120;

resourcestring
  html_title = 'HTMLEditor';
  
  html_caption1 = 'Otĕۑ';
  html_caption2 = '';
  html_caption3 = 'u';
  html_caption4 = 'vZbg̕ҏW';
  html_caption5 = 'Xg̕ҏW';
  html_caption6 = 'o[W';
  html_caption7 = 'VK';
  html_caption8 = 'AhDobt@̐ݒ';

  html_message1 = 'eύXĂ܂Bۑ܂H';
  html_message2 = '̃t@C͊ɑ݂܂B㏑܂H';
  html_message3 = 't@Cۑ܂B낵łH';
  html_message4 = 'ɐ܂B';
  html_message5 = '͌܂łB';
  html_message6 = 'SĂ̌u܂BAhD̓NA܂B'#13#10'낵łH';
  html_message7 = 'vZbgۑ܂B낵łH';
  html_message8 = 'eύXĂ܂Bj܂H';
  html_message9 = 'Xgۑ܂B낵łH';
  html_message10 = 'JEg܂B'#13#10'eʂɂĎԂꍇ܂B낵łH';
  html_message11 = 'L^AhĎ͂ĂB';

  html_error1 = 'HTMLXg̕ۑɎs܂B';
  html_error2 = 't@CJ܂B';
  html_error3 = 't@C݂܂B';
  html_error4 = 'RtBO̕ۑɎs܂B';
  html_error5 = 't@C̕ۑɎs܂B';
  html_error6 = 'vZbg̕ۑɎs܂B';
  html_error7 = 'sȕ񂪓͂܂B𒆒f܂B';

var
  // JgfBNg
  CurrentPath: String;

  // t@Cgqp^[iǉƂTypeCntƘAj
  FileTypes: Array[0 .. TypeCnt - 1] of TFileType =
  (
    (PaternName: 'HTML'; Patern: '.html'),
    (PaternName: 'TEXT'; Patern: '.txt'),
    (PaternName: 'OTHERS'; Patern: '.*'));

  // vZbgi[
  PresetList: TStringList;

  // HTMLXg
  HTMLList: TStringList;
  HTMLList1: TStringList;
  HTMLList2: TStringList;
  DescList: TStringList;

  // HTMLXgV[gJbg
  HTMLShort: Array[1 .. 12] of Integer;

  // AhD
  UndoMax: Integer = UndoMax_Default;
  UndoList: Array of TUndoList;
  UndoPoint: Array of Integer;
  UndoLength: Array of Integer;

  // f[^i[
  LoadData: Array of String;

implementation

end.
