unit HTMLFindReplace;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs;

type
  Tfrm_FindReplace = class(TForm)
    btn_Find: TButton;
    btn_ReplaceAll: TButton;
    edt_Find: TEdit;
    edt_Replace: TEdit;
    btn_Replace: TButton;
    btn_Cancel: TButton;
    lbl_Find: TLabel;
    lbl_Replace: TLabel;
    chk_CrLf: TCheckBox;
    chk_Reg: TCheckBox;
    rad_Up: TRadioButton;
    rad_Down: TRadioButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn_FindClick(Sender: TObject);
    procedure btn_ReplaceClick(Sender: TObject);
    procedure btn_CancelClick(Sender: TObject);
    procedure btn_ReplaceAllClick(Sender: TObject);
    procedure chk_RegClick(Sender: TObject);
    procedure chk_CrLfClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  frm_FindReplace: Tfrm_FindReplace;
  ReplaceMode: Boolean;
  FindWord: String = '';
  ReplaceWord: String = '';
  RegChecked: Boolean = False;
  CrLfChecked: Boolean = False;

implementation

uses
  HTMLMain, HTMLCommon, skRegExpW;

{$R *.dfm}

procedure Tfrm_FindReplace.btn_CancelClick(Sender: TObject);
begin
  Close;
end;

procedure Tfrm_FindReplace.btn_FindClick(Sender: TObject);
begin
  if edt_Find.Text = '' then
    Exit;

  FindWord := edt_Find.Text;
  frm_Main.FindString(FindWord, chk_Reg.Checked, rad_Up.Checked);
end;

procedure Tfrm_FindReplace.btn_ReplaceAllClick(Sender: TObject);
var
  TempStr: String;
  RegSearch: TSkRegExp;

begin
  if edt_Find.Text = '' then
    Exit;

  if MessageDlg(html_message6, mtConfirmation, [mbYes, mbNo], -1) = mrNo then
    Exit;

  FindWord := edt_Find.Text;
  ReplaceWord := edt_Replace.Text;
  TempStr := frm_Main.mem_Text.Text;
  if chk_Reg.Checked then
  begin
    RegSearch := TSkRegExp.Create;
    RegSearch.Expression := FindWord;
    if chk_CrLf.Checked then
      TempStr := RegSearch.Replace(TempStr, ReplaceWord + #13#10, True)
    else
      TempStr := RegSearch.Replace(TempStr, ReplaceWord, True);
    RegSearch.Free;
  end
  else
  begin
    if chk_CrLf.Checked then
      TempStr := StringReplace(TempStr, FindWord, ReplaceWord + #13#10, [rfReplaceAll])
    else
      TempStr := StringReplace(TempStr, FindWord, ReplaceWord, [rfReplaceAll]);
  end;
  frm_Main.mem_Text.Text := TempStr;

  frm_Main.men_UndoClear.Click;
end;

procedure Tfrm_FindReplace.btn_ReplaceClick(Sender: TObject);
begin
  if edt_Find.Text = '' then
    Exit;

  FindWord := edt_Find.Text;
  ReplaceWord := edt_Replace.Text;
  frm_Main.ReplaceString(FindWord, ReplaceWord, chk_Reg.Checked, chk_CrLf.Checked, rad_Up.Checked);
end;

procedure Tfrm_FindReplace.chk_CrLfClick(Sender: TObject);
begin
  if chk_CrLf.Checked then
    CrLfChecked := True
  else
    CrLfChecked := False;
end;

procedure Tfrm_FindReplace.chk_RegClick(Sender: TObject);
begin
  if chk_Reg.Checked then
    RegChecked := True
  else
    RegChecked := False;
end;

procedure Tfrm_FindReplace.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  edt_Find.Text := '';
  edt_Replace.Text := '';
end;

procedure Tfrm_FindReplace.FormShow(Sender: TObject);
begin
  edt_Find.Text := FindWord;
  edt_Replace.Text := '';

  if ReplaceMode then
  begin
    lbl_Replace.Visible := True;
    edt_Replace.Visible := True;
    btn_Replace.Visible := True;
    btn_ReplaceAll.Visible := True;
    edt_Replace.Text := ReplaceWord;
    chk_CrLf.Visible := True;
  end
  else
  begin
    lbl_Replace.Visible := False;
    edt_Replace.Visible := False;
    btn_Replace.Visible := False;
    btn_ReplaceAll.Visible := False;
    chk_CrLf.Visible := False;
  end;

  edt_Find.SetFocus;
end;

end.
