unit HTMLListEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  Tfrm_ListEdit = class(TForm)
    lst_HTML: TListBox;
    edt_Tag1: TEdit;
    edt_Tag2: TEdit;
    edt_Desc: TEdit;
    lbl_Tag1: TLabel;
    lbl_Tag2: TLabel;
    lbl_Desc: TLabel;
    btn_Set: TButton;
    btn_Add: TButton;
    btn_Delete: TButton;
    btn_Save: TButton;
    btn_Cancel: TButton;
    btn_Back: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btn_SetClick(Sender: TObject);
    procedure btn_AddClick(Sender: TObject);
    procedure btn_BackClick(Sender: TObject);
    procedure btn_DeleteClick(Sender: TObject);
    procedure btn_SaveClick(Sender: TObject);
    procedure btn_CancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lst_HTMLClick(Sender: TObject);
    procedure lst_HTMLKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
    procedure SetEdit(Index: Integer);
    procedure WMSysCommand(var Mes: TWMSysCommand); message WM_SYSCOMMAND;
  public
    { Public 錾 }
  end;

var
  frm_ListEdit: Tfrm_ListEdit;
  EditList: TStringList;
  EditList1: TStringList;
  EditList2: TStringList;
  EditList3: TStringList;
  CloseFlg: Boolean = True;

implementation

uses
  HTMLMain, HTMLCommon;

{$R *.dfm}

procedure Tfrm_ListEdit.btn_AddClick(Sender: TObject);
begin
  EditList.Add(edt_Tag1.Text + #9 + edt_Tag2.Text + #9 + edt_Desc.Text);
  EditList1.Add(edt_Tag1.Text);
  EditList2.Add(edt_Tag2.Text);
  EditList3.Add(edt_Desc.Text);

  lst_HTML.Items.Add(edt_Tag1.Text + #9 + edt_Tag2.Text);
  lst_HTML.ItemIndex := lst_HTML.Items.Count - 1;
end;

procedure Tfrm_ListEdit.btn_BackClick(Sender: TObject);
begin
  if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < EditList.Count) then
  begin
    edt_Tag1.Text := EditList1[lst_HTML.ItemIndex];
    edt_Tag2.Text := EditList2[lst_HTML.ItemIndex];
    edt_Desc.Text := EditList3[lst_HTML.ItemIndex];
  end
  else
  begin
    edt_Tag1.Text := '';
    edt_Tag2.Text := '';
    edt_Desc.Text := '';
  end;
end;

procedure Tfrm_ListEdit.btn_CancelClick(Sender: TObject);
begin
  if EditList.Text <> HTMLList.Text then
    if MessageDlg(html_message8, mtInformation, [mbYes, mbNo], -1) = mrNo then
    begin
      CloseFlg := False;
      Exit;
    end;

  CloseFlg := True;
end;

procedure Tfrm_ListEdit.btn_DeleteClick(Sender: TObject);
var
  Index: Integer;

begin
  if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < EditList.Count) then
  begin
    Index := lst_HTML.ItemIndex;

    EditList.Delete(Index);
    EditList1.Delete(Index);
    EditList2.Delete(Index);
    EditList3.Delete(Index);

    lst_HTML.Items.Delete(Index);

    if (Index >= 0) and (Index < EditList.Count) then
      lst_HTML.ItemIndex := Index
    else if Index - 1 >= 0 then
      lst_HTML.ItemIndex := Index - 1;
  end;
end;

procedure Tfrm_ListEdit.btn_SaveClick(Sender: TObject);
begin
  if EditList.Text <> HTMLList.Text then
  begin
    if MessageDlg(html_message9, mtConfirmation, [mbYes, mbNo], -1) = mrNo then
    begin
      CloseFlg := False;
      Exit;
    end;

    HTMLList.Clear;
    HTMLList1.Clear;
    HTMLList2.Clear;
    DescList.Clear;

    HTMLList.Text := EditList.Text;
    HTMLList1.Text := EditList1.Text;
    HTMLList2.Text := EditList2.Text;
    DescList.Text := EditList3.Text;

    frm_Main.SetHTMLList;
  end;

  CloseFlg := True;
end;

procedure Tfrm_ListEdit.btn_SetClick(Sender: TObject);
begin
  if (lst_HTML.ItemIndex >= 0) and (lst_HTML.ItemIndex < EditList.Count) then
  begin
    EditList[lst_HTML.ItemIndex] := edt_Tag1.Text + #9 + edt_Tag2.Text + #9 + edt_Desc.Text;
    EditList1[lst_HTML.ItemIndex] := edt_Tag1.Text;
    EditList2[lst_HTML.ItemIndex] := edt_Tag2.Text;
    EditList3[lst_HTML.ItemIndex] := edt_Desc.Text;

    lst_HTML.Items[lst_HTML.ItemIndex] := edt_Tag1.Text + #9 + edt_Tag2.Text;
  end
  else
    btn_Add.Click;
end;

procedure Tfrm_ListEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if CloseFlg then
  begin
    EditList.Free;
    EditList1.Free;
    EditList2.Free;
    EditList3.Free;
    Action := caHide;
  end
  else
    Action := caNone;

  CloseFlg := True;
end;

procedure Tfrm_ListEdit.FormCreate(Sender: TObject);
begin
  Caption := html_caption5;
end;

procedure Tfrm_ListEdit.FormShow(Sender: TObject);
var
  i: Integer;

begin
  EditList := TStringList.Create;
  EditList1 := TStringList.Create;
  EditList2 := TStringList.Create;
  EditList3 := TStringList.Create;

  EditList.Clear;
  EditList1.Clear;
  EditList2.Clear;
  EditList3.Clear;

  EditList.Text := HTMLList.Text;
  EditList1.Text := HTMLList1.Text;
  EditList2.Text := HTMLList2.Text;
  EditList3.Text := DescList.Text;

  lst_HTML.Clear;
  for i := 0 to EditList.Count - 1 do
    lst_HTML.Items.Add(EditList1[i] + #9 + EditList2[i]);
end;

procedure Tfrm_ListEdit.lst_HTMLClick(Sender: TObject);
begin
  SetEdit(lst_HTML.ItemIndex);
end;

procedure Tfrm_ListEdit.lst_HTMLKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = Vk_Return then
    SetEdit(lst_HTML.ItemIndex)
  else if Key in [Vk_Up, Vk_Down, Vk_Left, Vk_Right, Vk_Prior, Vk_Next, Vk_Home, Vk_End] then
    SetEdit(lst_HTML.ItemIndex);
end;

procedure Tfrm_ListEdit.SetEdit(Index: Integer);
begin
  if (Index >= 0) and (Index < EditList.Count) then
  begin
    edt_Tag1.Text := EditList1[Index];
    edt_Tag2.Text := EditList2[Index];
    edt_Desc.Text := EditList3[Index];
  end
  else
  begin
    edt_Tag1.Text := '';
    edt_Tag2.Text := '';
    edt_Desc.Text := '';
  end;
end;

procedure Tfrm_ListEdit.WMSysCommand(var Mes: TWMSysCommand);
begin
 if (Mes.CmdType and $FFF0 = SC_MINIMIZE) then
    Application.Minimize
  else
    inherited;
end;

end.
