unit HTMLPresetEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  Tfrm_PresetEdit = class(TForm)
    mem_Preset: TMemo;
    btn_Save: TButton;
    btn_Cancel: TButton;
    btn_Back: TButton;
    procedure FormShow(Sender: TObject);
    procedure btn_SaveClick(Sender: TObject);
    procedure btn_CancelClick(Sender: TObject);
    procedure btn_BackClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    procedure WMSysCommand(var Mes: TWMSysCommand); message WM_SYSCOMMAND;
  public
    { Public 錾 }
  end;

var
  frm_PresetEdit: Tfrm_PresetEdit;
  CloseFlg: Boolean = True;

implementation

uses
  HTMLMain, HTMLCommon;

{$R *.dfm}

procedure Tfrm_PresetEdit.btn_BackClick(Sender: TObject);
begin
  if mem_Preset.Text <> PresetList.Text then
  begin
    if MessageDlg(html_message8, mtConfirmation, [mbYes, mbNo], -1) = mrNo then
    begin
      CloseFlg := False;
      Exit;
    end;

    mem_Preset.Clear;
    mem_Preset.Text := PresetList.Text;
  end;

  CloseFlg := True;
end;

procedure Tfrm_PresetEdit.btn_CancelClick(Sender: TObject);
begin
  if mem_Preset.Text <> PresetList.Text then
    if MessageDlg(html_message8, mtConfirmation, [mbYes, mbNo], -1) = mrNo then
    begin
      CloseFlg := False;
      Exit;
    end;

  CloseFlg := True;
end;

procedure Tfrm_PresetEdit.btn_SaveClick(Sender: TObject);
begin
  if mem_Preset.Text <> PresetList.Text then
  begin
    if MessageDlg(html_message7, mtConfirmation, [mbYes, mbNo], -1) = mrNo then
    begin
      CloseFlg := False;
      Exit;
    end;

    PresetList.Clear;
    PresetList.Text := mem_Preset.Text;
  end;

  CloseFlg := True;
end;

procedure Tfrm_PresetEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if CloseFlg then
    Action := caHide
  else
    Action := caNone;

  CloseFlg := True;
end;

procedure Tfrm_PresetEdit.FormCreate(Sender: TObject);
begin
  Caption := html_caption4;
end;

procedure Tfrm_PresetEdit.FormShow(Sender: TObject);
begin
  mem_Preset.Clear;
  mem_Preset.Text := PresetList.Text;
  mem_Preset.SetFocus;
end;

procedure Tfrm_PresetEdit.WMSysCommand(var Mes: TWMSysCommand);
begin
 if (Mes.CmdType and $FFF0 = SC_MINIMIZE) then
    Application.Minimize
  else
    inherited;
end;

end.
