unit HTMLSave;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, FileCtrl, Menus, Dialogs;

type
  Tfrm_SaveAs = class(TForm)
    btn_Save: TButton;
    btn_Cancel: TButton;
    fil_File: TFileListBox;
    dir_Directory: TDirectoryListBox;
    cmb_FileType: TComboBox;
    edt_FileName: TEdit;
    pop_Dummy: TPopupMenu;
    drv_Drive: TDriveComboBox;
    procedure cmb_FileTypeKeyPress(Sender: TObject; var Key: Char);
    procedure cmb_FileTypeChange(Sender: TObject);
    procedure btn_SaveClick(Sender: TObject);
    procedure edt_FileNameKeyPress(Sender: TObject; var Key: Char);
    procedure fil_FileClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn_CancelClick(Sender: TObject);
  private
    { Private 錾 }
    procedure SetFileType;
  public
    { Public 錾 }
  end;

var
  frm_SaveAs: Tfrm_SaveAs;
  CloseFlg: Boolean = True;

implementation

uses
  HTMLMain, HTMLCommon;

{$R *.dfm}

procedure Tfrm_SaveAs.cmb_FileTypeKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0;
end;

procedure Tfrm_SaveAs.edt_FileNameKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key in ['\', '/', ':', '*', '?', '"', '<', '>', '|']) then
    Key := #0;
end;

procedure Tfrm_SaveAs.fil_FileClick(Sender: TObject);
begin
  if (fil_File.ItemIndex >= 0) and (fil_File.ItemIndex < fil_File.Count) then
    edt_FileName.Text := fil_File.Items[fil_File.ItemIndex];
end;

procedure Tfrm_SaveAs.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if CloseFlg then
    Action := caHide
  else
    Action := caNone;

  CloseFlg := True;
end;

procedure Tfrm_SaveAs.FormCreate(Sender: TObject);
begin
  Caption := html_caption1;
  SetFileType;

  dir_Directory.Directory := frm_Main.dir_Directory.Directory;
  fil_File.Directory := dir_Directory.Directory;
end;

procedure Tfrm_SaveAs.SetFileType;
var
  i: Integer;

begin
  // t@C^Cv̐ݒ
  cmb_FileType.Clear;

  for i := 0 to TypeCnt - 1 do
  begin
    cmb_FileType.Items.Add(FileTypes[i].PaternName);
  end;

  cmb_FileType.ItemIndex := 0;
  fil_File.Mask := '*' + FileTypes[0].Patern;
end;

procedure Tfrm_SaveAs.btn_CancelClick(Sender: TObject);
begin
  CloseFlg := True;
end;

procedure Tfrm_SaveAs.btn_SaveClick(Sender: TObject);
var
  FilePath: String;
  FileName: String;

begin
  CloseFlg := True;

  FilePath := dir_Directory.Directory;
  FileName := edt_FileName.Text;

  if FileTypes[cmb_FileType.ItemIndex].Patern <> '.*' then
  begin
    if Pos('.', FileName) > 0 then
    begin
      if Copy(FileName, Length(FileName) - Length(FileTypes[cmb_FileType.ItemIndex].Patern) + 1, Length(FileName))
         <> FileTypes[cmb_FileType.ItemIndex].Patern then
        FileName := FileName + FileTypes[cmb_FileType.ItemIndex].Patern;
    end
    else
      FileName := FileName + FileTypes[cmb_FileType.ItemIndex].Patern;
  end;

  if FileExists(FilePath + '\' + FileName) then
  begin
    if MessageDlg(html_message2, mtConfirmation, [mbYes, mbNo], -1) = mrNo then
    begin
      CloseFlg := False;
      Exit;
    end;
  end;

  frm_Main.SaveFile(FilePath + '\' + FileName);
end;

procedure Tfrm_SaveAs.cmb_FileTypeChange(Sender: TObject);
begin
  if (cmb_FileType.ItemIndex >= 0) and (cmb_FileType.ItemIndex < TypeCnt) then
    fil_File.Mask := '*' + FileTypes[cmb_FileType.ItemIndex].Patern;
end;

end.
